clear all
clc
userpath('C:\Users\Administrator\Desktop\Data and program\Signaling pathway')
%sens=csvread('sens-scoreIC_5032.csv',1,1);
%sens1=csvread('sens-scoreIC_50NaN32.csv',1,1);
%cell=csvread('pearson-cell.csv',1,1);
%drug=csvread('t-open32.csv',1,1);
load('sens.mat');%sens
load('sens1.mat');%sens1
load('cell.mat');
load('drug.mat');
[m,n]=size(sens);
[c,d]=find(isnan(sens1));
WC=zeros(size(cell));
WD=zeros(size(drug));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Selection of optimal parameters
A=zeros(100,100);
NU=zeros(size(sens));%numerator
DE=zeros(size(sens));%denominator 
sens_p=zeros(size(sens));
DE1=zeros(size(sens));
NU1=zeros(size(sens));
for q=0.01:0.01:1
for p=0.01:0.01:1
for j=1:m
    for i=1:m
        WC(i,j)=exp(-(1-cell(i,j)).^2/(2*p^2));
    end
end
for j=1:n
    for i=1:n
        WD(i,j)=exp(-(1-drug(i,j)).^2/(2*q^2));
    end
end
     P=int64(100*p);
     Q=int64(100*q);
for b=1:n
      disp(['', num2str(b), 'b%%%%%%%%%%%%%%%%%%%%%%%%%'])
    for a=1:m
    for j=1:n
    for i=1:m
 if((j~=b&&i~=a)&&sens(i,j)~=0)
         NU(i,j)=WC(a,i)*WD(b,j)*sens(i,j);
         DE(i,j)=WC(a,i)*WD(b,j);
               else
             NU(i,j)=0;
             DE(i,j)=0;
 end
    end
    end
    NU1(a,b)=sum(sum(NU(:)));
    DE1(a,b)=sum(sum(DE(:)));
    sens_p(a,b)=NU1(a,b)./DE1(a,b);
    end
end
for i=1:5517
sens_p(c(i),d(i))=0;
end
A(P,Q)=sum(sum((sens_p-sens).^2));
end
end
%0.04 0.18
 clear DE1 NU1 DE NU sens_p WC WD 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Formal procedure
NU=zeros(size(sens));
DE=zeros(size(sens));
sens_p=zeros(size(sens));
DE1=zeros(size(sens));
NU1=zeros(size(sens));
WC=zeros(size(cell));
WD=zeros(size(drug));
COL=zeros(100,100);
for j=1:m
    for i=1:m
        WC(i,j)=exp(-(1-cell(i,j)).^2/(2*0.04^2));
    end
end
for j=1:n
    for i=1:n
        WD(i,j)=exp(-(1-drug(i,j)).^2/(2*0.18^2));
    end 
end

 for b=1:n
      disp(['', num2str(b), 'b%%%%%%%%%%%%%%%%%%%%%%%%%'])
    for a=1:m
    for j=1:n
    for i=1:m
 if((j~=b&&i~=a)&&sens(i,j)~=0)
     NU(i,j)=WC(a,i)*sens(i,j)*WD(b,j);   
     DE(i,j)=WC(a,i)*WD(b,j);
       else
             NU(i,j)=0;
             DE(i,j)=0;
 end
    end
    end
    NU1(a,b)=sum(sum(NU(:)));
    DE1(a,b)=sum(sum(DE(:)));
    sens_p(a,b)=NU1(a,b)./DE1(a,b);
    end
 end
for i=1:5517
sens_p(c(i),d(i))=0;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Column calculation
 R=zeros(32,1);
RMSE=zeros(32,1);
NRMSE=zeros(32,1);
for i=1:32
    sens_p1=sens_p(sens_p(:,i)~=0,i); 
    sens2=sens(sens(:,i)~=0,i);
 A1=corrcoef(sens_p1,sens2);
 R(i,1)=A1(1,2);
 rmse=(sens2-sens_p1).*(sens2-sens_p1);
RMSE(i,1)=sqrt(sum(rmse(:))/nnz(sens_p1));
NRMSE(i,1)=RMSE(i,1)/(max(sens2)-min(sens2));
end
